#include <P18F4550.h>
#include <P18F4550_bits.h>
#include <PortBits.h>
#include <datalib.h>
#include <usbcdc.h>

#define APROCFREQ 20000000

#define BITSIZE 16
#define BOOTADDRESS 0
#define FIRSTRAM 0x00
#define LASTRAM 0x7FF
#define HASOSCCAL 0
#define nPAGESRAM 1
#define nPAGESROM 1
//
// Header file - should be included in all C files used within the program
// This file is created automatically and should not be changed
//

//
// Functions
//
void UserInitialise();			// Your initialisation code
void UserInterrupt();			// Your interrupt code
void UserLoop();			// your Main loop code


#define SimpButnCopy 9
#pragma asmline _SimpButnCopy=9
#define PortOutnCopy 11
// **********
//
// Simple Switch
//
// **********
#define SimpButUsed 1
#pragma asmline _SimpButUsed=1
#define SimpBut8Used 1
#pragma asmline _SimpBut8Used=1
#pragma asmline _SBPress8Used=1
#pragma asmline _SBPress8Flag=Flag1
#pragma asmline _SBPress8FlagBit=0
#define SBPress8Used 1
#define SBPress8Flag Flag1
#define SBPress8FlagBit 0
void Sense();
#define InitialDelay8 500
#pragma asmline _InitialDelay8=500
#define RepDelay8 250
#pragma asmline _RepDelay8=250
#define Debounce8 60
#pragma asmline _Debounce8=60
#define EnableRepeat8 0
#pragma asmline _EnableRepeat8=0
#define Invert8 0
#pragma asmline _Invert8=0
#define SBIn8Port PORTB
#define SBIn8Bit 4
#define SENSEPort PORTB
#define SENSEBit 4
#define SENSE bRB4
#define SENSETris bTRB4
#pragma asmline _SBIn8Port=PORTB
#pragma asmline _SBIn8Bit=4
#pragma asmline _SENSEPort=PORTB
#pragma asmline _SENSEBit=4
// **********
//
// Simple Switch
//
// **********
#define SimpBut7Used 1
#pragma asmline _SimpBut7Used=1
#define InitialDelay7 500
#pragma asmline _InitialDelay7=500
#define RepDelay7 250
#pragma asmline _RepDelay7=250
#define Debounce7 60
#pragma asmline _Debounce7=60
#define EnableRepeat7 0
#pragma asmline _EnableRepeat7=0
#define Invert7 0
#pragma asmline _Invert7=0
#define SBIn7Port PORTB
#define SBIn7Bit 3
#define HANDBRAKEPort PORTB
#define HANDBRAKEBit 3
#define HANDBRAKE bRB3
#define HANDBRAKETris bTRB3
#pragma asmline _SBIn7Port=PORTB
#pragma asmline _SBIn7Bit=3
#pragma asmline _HANDBRAKEPort=PORTB
#pragma asmline _HANDBRAKEBit=3
// **********
//
// Simple Switch
//
// **********
#define SimpBut6Used 1
#pragma asmline _SimpBut6Used=1
#define InitialDelay6 500
#pragma asmline _InitialDelay6=500
#define RepDelay6 250
#pragma asmline _RepDelay6=250
#define Debounce6 60
#pragma asmline _Debounce6=60
#define EnableRepeat6 0
#pragma asmline _EnableRepeat6=0
#define Invert6 0
#pragma asmline _Invert6=0
#define SBIn6Port PORTB
#define SBIn6Bit 2
#define BRAKESPort PORTB
#define BRAKESBit 2
#define BRAKES bRB2
#define BRAKESTris bTRB2
#pragma asmline _SBIn6Port=PORTB
#pragma asmline _SBIn6Bit=2
#pragma asmline _BRAKESPort=PORTB
#pragma asmline _BRAKESBit=2
// **********
//
// Simple Switch
//
// **********
#define SimpBut5Used 1
#pragma asmline _SimpBut5Used=1
#define InitialDelay5 500
#pragma asmline _InitialDelay5=500
#define RepDelay5 250
#pragma asmline _RepDelay5=250
#define Debounce5 60
#pragma asmline _Debounce5=60
#define EnableRepeat5 0
#pragma asmline _EnableRepeat5=0
#define Invert5 0
#pragma asmline _Invert5=0
#define SBIn5Port PORTD
#define SBIn5Bit 7
#define PRESSUREPort PORTD
#define PRESSUREBit 7
#define PRESSURE bRD7
#define PRESSURETris bTRD7
#pragma asmline _SBIn5Port=PORTD
#pragma asmline _SBIn5Bit=7
#pragma asmline _PRESSUREPort=PORTD
#pragma asmline _PRESSUREBit=7
// **********
//
// Simple Switch
//
// **********
#define SimpBut4Used 1
#pragma asmline _SimpBut4Used=1
#define InitialDelay4 500
#pragma asmline _InitialDelay4=500
#define RepDelay4 250
#pragma asmline _RepDelay4=250
#define Debounce4 60
#pragma asmline _Debounce4=60
#define EnableRepeat4 0
#pragma asmline _EnableRepeat4=0
#define Invert4 0
#pragma asmline _Invert4=0
#define SBIn4Port PORTD
#define SBIn4Bit 6
#define OVERHEATPort PORTD
#define OVERHEATBit 6
#define OVERHEAT bRD6
#define OVERHEATTris bTRD6
#pragma asmline _SBIn4Port=PORTD
#pragma asmline _SBIn4Bit=6
#pragma asmline _OVERHEATPort=PORTD
#pragma asmline _OVERHEATBit=6
// **********
//
// Simple Switch
//
// **********
#define SimpBut3Used 1
#pragma asmline _SimpBut3Used=1
#pragma asmline _SBPress3Used=1
#pragma asmline _SBPress3Flag=Flag1
#pragma asmline _SBPress3FlagBit=1
#define SBPress3Used 1
#define SBPress3Flag Flag1
#define SBPress3FlagBit 1
void doors();
#define InitialDelay3 500
#pragma asmline _InitialDelay3=500
#define RepDelay3 250
#pragma asmline _RepDelay3=250
#define Debounce3 60
#pragma asmline _Debounce3=60
#define EnableRepeat3 0
#pragma asmline _EnableRepeat3=0
#define Invert3 0
#pragma asmline _Invert3=0
#define SBIn3Port PORTC
#define SBIn3Bit 0
#define DOORSPort PORTC
#define DOORSBit 0
#define DOORS bRC0
#define DOORSTris bTRC0
#pragma asmline _SBIn3Port=PORTC
#pragma asmline _SBIn3Bit=0
#pragma asmline _DOORSPort=PORTC
#pragma asmline _DOORSBit=0
// **********
//
// Simple Switch
//
// **********
#define SimpBut2Used 1
#pragma asmline _SimpBut2Used=1
#pragma asmline _SBPress2Used=1
#pragma asmline _SBPress2Flag=Flag1
#pragma asmline _SBPress2FlagBit=2
#define SBPress2Used 1
#define SBPress2Flag Flag1
#define SBPress2FlagBit 2
void hold();
#define InitialDelay2 500
#pragma asmline _InitialDelay2=500
#define RepDelay2 250
#pragma asmline _RepDelay2=250
#define Debounce2 60
#pragma asmline _Debounce2=60
#define EnableRepeat2 0
#pragma asmline _EnableRepeat2=0
#define Invert2 0
#pragma asmline _Invert2=0
#define SBIn2Port PORTE
#define SBIn2Bit 2
#define INHIBITPort PORTE
#define INHIBITBit 2
#define INHIBIT bRE2
#define INHIBITTris bTRE2
#pragma asmline _SBIn2Port=PORTE
#pragma asmline _SBIn2Bit=2
#pragma asmline _INHIBITPort=PORTE
#pragma asmline _INHIBITBit=2
// **********
//
// Simple Switch
//
// **********
#define SimpBut1Used 1
#pragma asmline _SimpBut1Used=1
#pragma asmline _SBPress1Used=1
#pragma asmline _SBPress1Flag=Flag1
#pragma asmline _SBPress1FlagBit=3
#define SBPress1Used 1
#define SBPress1Flag Flag1
#define SBPress1FlagBit 3
void down();
#define InitialDelay1 500
#pragma asmline _InitialDelay1=500
#define RepDelay1 250
#pragma asmline _RepDelay1=250
#define Debounce1 60
#pragma asmline _Debounce1=60
#define EnableRepeat1 0
#pragma asmline _EnableRepeat1=0
#define Invert1 0
#pragma asmline _Invert1=0
#define SBIn1Port PORTE
#define SBIn1Bit 1
#define DOWNPort PORTE
#define DOWNBit 1
#define DOWN bRE1
#define DOWNTris bTRE1
#pragma asmline _SBIn1Port=PORTE
#pragma asmline _SBIn1Bit=1
#pragma asmline _DOWNPort=PORTE
#pragma asmline _DOWNBit=1
// **********
//
// Timer 0
//
// **********
#define Tmr0Used 1
void SBT0Of();
#define UsePS 1
#define PSD 4
#define CRE 1
#define UseOsc 1
#define EnableT0 1
#define T0is8Bit 1
// **********
//
// Simple Switch
//
// **********
#define SimpBut0Used 1
#pragma asmline _SimpBut0Used=1
#pragma asmline _SBPress0Used=1
#pragma asmline _SBPress0Flag=Flag1
#pragma asmline _SBPress0FlagBit=4
#define SBPress0Used 1
#define SBPress0Flag Flag1
#define SBPress0FlagBit 4
void up();
#define InitialDelay0 500
#pragma asmline _InitialDelay0=500
#define RepDelay0 250
#pragma asmline _RepDelay0=250
#define Debounce0 60
#pragma asmline _Debounce0=60
#define EnableRepeat0 0
#pragma asmline _EnableRepeat0=0
#define Invert0 0
#pragma asmline _Invert0=0
#define SBIn0Port PORTE
#define SBIn0Bit 0
#define UPPort PORTE
#define UPBit 0
#define UP bRE0
#define UPTris bTRE0
#pragma asmline _SBIn0Port=PORTE
#pragma asmline _SBIn0Bit=0
#pragma asmline _UPPort=PORTE
#pragma asmline _UPBit=0
// **********
//
// Port Driver
//
// **********
#define PortOutUsed 1
#define PortOut10Used 1
#define InitialValue10 0
#define Out10Port PORTB
#define Out10Bit 5
#define COMPPWRPort PORTB
#define COMPPWRBit 5
#define COMPPWR bRB5
#define COMPPWRTris bTRB5
// **********
//
// Port Driver
//
// **********
#define PortOut9Used 1
#define InitialValue9 1
#define Out9Port PORTB
#define Out9Bit 1
#define RHSW_CLKPort PORTB
#define RHSW_CLKBit 1
#define RHSW_CLK bRB1
#define RHSW_CLKTris bTRB1
// **********
//
// Port Driver
//
// **********
#define PortOut8Used 1
#define InitialValue8 1
#define Out8Port PORTB
#define Out8Bit 0
#define RHSW_DATAPort PORTB
#define RHSW_DATABit 0
#define RHSW_DATA bRB0
#define RHSW_DATATris bTRB0
// **********
//
// Port Driver
//
// **********
#define PortOut7Used 1
#define InitialValue7 0
#define Out7Port PORTD
#define Out7Bit 5
#define SINPPort PORTD
#define SINPBit 5
#define SINP bRD5
#define SINPTris bTRD5
// **********
//
// Port Driver
//
// **********
#define PortOut6Used 1
#define InitialValue6 0
#define Out6Port PORTD
#define Out6Bit 4
#define SEXHPort PORTD
#define SEXHBit 4
#define SEXH bRD4
#define SEXHTris bTRD4
// **********
//
// Port Driver
//
// **********
#define PortOut5Used 1
#define InitialValue5 0
#define Out5Port PORTD
#define Out5Bit 3
#define SRLPort PORTD
#define SRLBit 3
#define SRL bRD3
#define SRLTris bTRD3
// **********
//
// Port Driver
//
// **********
#define PortOut4Used 1
#define InitialValue4 0
#define Out4Port PORTD
#define Out4Bit 2
#define SRRPort PORTD
#define SRRBit 2
#define SRR bRD2
#define SRRTris bTRD2
// **********
//
// Port Driver
//
// **********
#define PortOut3Used 1
#define InitialValue3 0
#define Out3Port PORTD
#define Out3Bit 1
#define SLFPort PORTD
#define SLFBit 1
#define SLF bRD1
#define SLFTris bTRD1
// **********
//
// Port Driver
//
// **********
#define PortOut2Used 1
#define InitialValue2 0
#define Out2Port PORTD
#define Out2Bit 0
#define SRFPort PORTD
#define SRFBit 0
#define SRF bRD0
#define SRFTris bTRD0
// **********
//
// Port Driver
//
// **********
#define PortOut1Used 1
#define InitialValue1 0
#define Out1Port PORTA
#define Out1Bit 4
#define LED2Port PORTA
#define LED2Bit 4
#define LED2 bRA4
#define LED2Tris bTRA4
// **********
//
// Port Driver
//
// **********
#define PortOut0Used 1
#define InitialValue0 0
#define Out0Port PORTA
#define Out0Bit 3
#define LED1Port PORTA
#define LED1Bit 3
#define LED1 bRA3
#define LED1Tris bTRA3
// **********
//
// A/D converter 18x
//
// **********
#define AD18xBitUsed 1
void adDone();
#define ADEn 1
#define InChan 0
#define ADClock OscDiv32
#define ADnChan 5
#define vADFM 1
#define ADACQ TAd4
#define VRefSrcP VRef_Vdd
#define VRefSrcM VRef_Vss
#define A0Port PORTA
#define A0Bit 0
#define AFRPort PORTA
#define AFRBit 0
#define AFR bRA0
#define AFRTris bTRA0
#define A1Port PORTA
#define A1Bit 1
#define AFLPort PORTA
#define AFLBit 1
#define AFL bRA1
#define AFLTris bTRA1
#define A2Port PORTA
#define A2Bit 2
#define ARRPort PORTA
#define ARRBit 2
#define ARR bRA2
#define ARRTris bTRA2
#define A3VRefPort PORTA
#define A3VRefBit 3
#define A4Port PORTA
#define A4Bit 5
#define ARLPort PORTA
#define ARLBit 5
#define ARL bRA5
#define ARLTris bTRA5
#define A5Port PORTE
#define A5Bit 0
#define A6Port PORTE
#define A6Bit 1
#define A7Port PORTE
#define A7Bit 2
#define A8Port PORTB
#define A8Bit 2
#define A9Port PORTB
#define A9Bit 3
#define A10Port PORTB
#define A10Bit 1
#define A11Port PORTB
#define A11Bit 4
#define A12Port PORTB
#define A12Bit 0
// **********
//
// Data EEPROM
//
// **********
#define EEPROMUsed 1
#define EEPROMIntUsed 1
#define EEFinUsed 1
#define EEFinFlag Flag1
#define EEFinFlagBit 5
void eeDone();
#define ReadAtInit 1
#define ReadInitAddr 0
// **********
//
// Serial Interface using USART hardware
//
// **********
#define USARTUsed 1
#pragma asmline _USARTUsed=1
void rxSerial();
#define SERINTRATE 9600
#pragma asmline _SERINTRATE=9600
#define RxPort PORTC
#define RxBit 7
#pragma asmline _RxPort=PORTC
#pragma asmline _RxBit=7
#define TxPort PORTC
#define TxBit 6
#pragma asmline _TxPort=PORTC
#pragma asmline _TxBit=6
// **********
//
// Capture Module 2
//
// **********
#define Cap2Used 1
void frpm();
#define CaptureWhen2 CaptureFalling
#define Capture2Port PORTC
#define Capture2Bit 1
#define ENGINE_SPEEDPort PORTC
#define ENGINE_SPEEDBit 1
#define ENGINE_SPEED bRC1
#define ENGINE_SPEEDTris bTRC1
// **********
//
// Timer 3
//
// **********
#define Tmr3Used 1
void mSec();
#define EnTimer3 1
#define T3_UseOsc 0
#define SyncT3Inp 0
#define T3_PSV 1
#define T3_CCPEn T1_SrcBoth
#define T3_RD16 0
// **********
//
// Timer 1
//
// **********
#define Tmr1Used 1
#define EnTimer1 1
#define T1_UseOsc 1
#define SyncT1Inp 1
#define EnT1Osc 0
#define T1_PSD 8
#define T1_16Bit 0
// **********
//
// Capture Module 1
//
// **********
#define Cap1Used 1
void fmph();
#define CaptureWhen1 CaptureFalling
#define Capture1Port PORTC
#define Capture1Bit 2
#define ROAD_SPEEDPort PORTC
#define ROAD_SPEEDBit 2
#define ROAD_SPEED bRC2
#define ROAD_SPEEDTris bTRC2
// **********
//
// USB CDC element
//
// **********
#define USBCDCUsed 1
void WizUSBTasks();
#define USBByteRxUsed 1
#define USBByteRxFlag Flag1
#define USBByteRxFlagBit 6
void rxUSB();
#define MChipBL 1
#define UseUSBLED 1
#define StdConfig 1
#define WizVendorID 6017
#define WizProductID 2570
#define USBLED1Port PORTB
#define USBLED1Bit 7
#define USBLED2Port PORTB
#define USBLED2Bit 6

// **********
//
// Application Designer Variables
//
// **********
extern unsigned char register Flag1;


// Defines specified by 1 or more elements

